import java.awt.*;
import java.util.Random;
public class HardGeneric <T extends EntityBus,U extends IDrawDoors> {
    T[] buses;
    U[] doors;
    private int busesNumber;
    private int doorsNumber;
    private int pictureBoxWidth;
    private int pictureBoxHeight;
    public HardGeneric(int busesCount, int doorsCount, int width, int height) {
        busesNumber = 0;
        doorsNumber = 0;
        buses = (T[]) new EntityBus[busesCount];
        doors = (U[]) new IDrawDoors[doorsCount];
        pictureBoxHeight = height;
        pictureBoxWidth = width;
    }

    public int insertBuses(T entityBus) {
        if (buses[buses.length - 1] != null)
            return -1;
        for (int i = busesNumber - 1; i >= 0; i--) {
            buses[i + 1] = buses[i];
        }
        busesNumber++;
        buses[0] = entityBus;
        return 0;
    }

    public int insertDoors(U door) {
        if (doors[doors.length - 1] != null)
            return -1;
        for (int i = doorsNumber - 1; i >= 0; i--) {
            doors[i + 1] = doors[i];
        }
        doorsNumber++;
        doors[0] = door;
        return 0;
    }

    public DrawingBus makeObject() {
        Random rand = new Random();
        EntityBus entity = buses[rand.nextInt(0, busesNumber)];
        IDrawDoors door = doors[rand.nextInt(0, doorsNumber)];
        if (entity instanceof EntityTrolleybus) {
            return new DrawingTrolleybus(entity.getSpeed(), entity.getWeight(), entity.getBodyColor(),
                    ((EntityTrolleybus) entity).getAdditionalColor(), ((EntityTrolleybus) entity).getRoga(),
                    ((EntityTrolleybus) entity).getBattery(), pictureBoxWidth, pictureBoxHeight, door.getNumber(), door.getType());

        }
        return new DrawingBus(entity.getSpeed(), entity.getWeight(), entity.getBodyColor(),
                pictureBoxWidth, pictureBoxHeight, door.getNumber(), door.getType());
    }
    public EntityBus makeRandomBus() {
        Random random = new Random();
        EntityBus bus;
        switch (random.nextInt(2)) {
            case 0 -> bus = new EntityBus(random.nextInt(100, 300), random.nextDouble(1000, 3000),
                    new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)));
            default -> bus = new EntityTrolleybus(random.nextInt(100, 300), random.nextDouble(1000, 3000),
                    new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                    new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                    random.nextBoolean(), random.nextBoolean());
        }
        return bus;
    }
    public IDrawDoors makeRandomDoor(){
        Random random = new Random();
        IDrawDoors door;
        switch (random.nextInt(3)){
            case 1 -> door = new DrawingDoorsRoundedUp();
            case 2 -> door = new DrawingDoorsRoundedUpAndDown();
            default -> door = new DrawingDoors();
        }
        door.setNumber((random.nextInt(3) + 1) * 2);
        return door;
    }
}
