import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;
public class SetGeneric<T extends Object>{
    private final List<T> places;
    private final int maxCount;
    public int getCount() {return places.size();}
    public SetGeneric(int count){
        maxCount = count;
        places = new ArrayList<>();
    }
    public boolean insert(T bus){
        if(places.size() == maxCount)
            return false;
        return insert(bus, 0);
    }
    public boolean insert(T bus, int position){
        if (!(position >= 0 && position <= places.size() && places.size() < maxCount))
            return false;
        places.add(position, bus);
        return true;
    }
    public boolean remove(int position){
        if(!(position >= 0 && position < getCount()))
            return false;
        places.remove(position);
        return true;
    }
    public T Get(int position){
        if(!(position >= 0 && position < getCount()))
            return null;
        return (T)places.get(position);
    }
    public ArrayList<T> GetBuses(int maxBuses){
        ArrayList<T> toRet = new ArrayList<>();
        for(int i = 0; i < places.size(); i++){
            toRet.add(places.get(i));
            if(i == maxBuses)
                return toRet;
        }
        return toRet;
    }
}
